#include "StdAfx.h"
#include "NoteModel.h"
#include "json.h"
#include "afxwin.h"
#include "SendNoteMananger.h"



CNoteModel::CNoteModel(void)
	: m_strLanguage(L"ko_KR")
	,m_strNotiCheck(L"N")
	,m_strReservationCheck(L"N")
	,m_strReservationTime(L"0")
	,m_nSendMaxUser(50)
	,m_strPartyCheck(L"N")
{
    //m_lNoteBoxID = 0;	
}

CNoteModel::~CNoteModel(void)
{
}

/*!
*  @fn BOOL SendMemo()
*  @brief       Ѵ
*  @return    TRUE  FALSE 
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning   Ticket  ʱȭ         ִ. 
			   SetTicket .
*/
BOOL CNoteModel::SendMemo(trid_t &trid)
{
	MakeSendNoteData(m_sSendNoteData);

	BOOL bRet = g_pMessengerActor->GetWASActor()->RequestSendNote(m_sSendNoteData, &trid);

	return bRet == TRUE ? true : false;
}

void CNoteModel::MakeSendFormData(std::string &strFormData)
{
	const char* chTicket		= "ticket=";
	const char* chList			= "&toIdList=";
	const char* chTitle			= "&noteTtl=";
	const char* chNoteContent	= "&noteContent=";
	const char* chRsvCheck		= "&rsvDsphYn=";
	const char* chRsvDate		= "&rsvDsphYmdt=";
	const char* chTimeZone		= "&tmTpCd=";
	const char* chAttachID		= "&attachId=";
	const char* chLang			= "&defaultLanguage=";
	const char* chParty         = "&relRcvrYn=";

	std::string strToList		= UnicodeToURIEncode(GetReceiverIDs());
	std::string strTitle		= UnicodeToURIEncode(m_strSubject);
	std::string strNoteContent	= UnicodeToURIEncode(m_strContent);
	std::string strRsvCheck		= UnicodeToURIEncode(m_strReservationCheck);
	std::string strRsvDate		= UnicodeToURIEncode(m_strReservationTime);
	std::string	strTimeZone		= UnicodeToURIEncode(m_strTimeZone);
	std::string strAttachID		= UnicodeToURIEncode(m_strAttachID);
	std::string strLang			= UnicodeToURIEncode(m_strLanguage);
	std::string strParty		= UnicodeToURIEncode(m_strPartyCheck);

	strFormData = chTicket		+ m_strTicket
				+ chList		+ strToList
				+ chTitle		+ strTitle
				+ chNoteContent + strNoteContent
				+ chRsvCheck	+ strRsvCheck
				+ chRsvDate		+ strRsvDate
				+ chTimeZone	+ strTimeZone
				+ chAttachID	+ strAttachID
				+ chLang		+ strLang
				+ chParty       + strParty;
}

void CNoteModel::MakeSendNoteData(NT_NOTE_SEND_DATA &sSendNoteData)
{
	//m_strUserIDs = ;

	sSendNoteData.strToList			= GetReceiverIDs();
	sSendNoteData.strTitle			= m_strSubject;
	sSendNoteData.strNoteContent	= m_strContent;
	sSendNoteData.strRsvCheck		= m_strReservationCheck;
	sSendNoteData.strRsvDate		= m_strReservationTime;
	sSendNoteData.strTimeZone		= m_strTimeZone;
	sSendNoteData.strAttachID		= m_strAttachID;
	sSendNoteData.strLang			= GetLanguageStringUnicode();
	sSendNoteData.strParty			= m_strPartyCheck;
}


/*!
*  @fn CString GetReceiverIDs()
*  @brief       Cstring ·  Ѵ.  UI ſ 
*  @return    ̸<̵>;̸2<̵2> · 
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning   𵨿 ڸ  ϳ,  ۽ó UI  Լ  Ѵ.
*/CString CNoteModel::GetReceiverIDs()
{
	CString str=_T("");
	for( std::vector<ReceiverInfo>::const_iterator iter = m_receiverVector.begin(); iter != m_receiverVector.end(); ++iter )
	{
		str.AppendFormat(_T("%s<%s>;"),iter->strName.c_str(), iter->strID.c_str());
	}
	return str;
}

/*
	( ߰ )
	 : NONE
		50 ߰
	 : NT01 | NT02
		÷εǾ ִ  뷮 10M ۰ų ̸, 1000 ߰
		÷εǾ ִ  뷮 10M ũ, 30M ۰ų ̸, 50 ߰ 
		÷εǾ ִ  뷮 30M ũ, 500M ۰ų ̸, 10 ߰ 
	 : NT01
		÷εǾ ִ  뷮 30M ۰ų ̸, 50 ߰
		÷εǾ ִ  뷮 30M ũ̸, 10 ߰
	 : NT02
		÷εǾ ִ  뷮 10M ũ̸, 50 ߰
		÷εǾ ִ  뷮 10M ۰ų ̸, 1000 ߰
*/
LRESULT CNoteModel::IsEnableReceiverUserCount(int nCurrentUser)
{	
	LRESULT res = 0L;
	EMemoAuth enumAuth = GetMemoAuth();	

	if( enumAuth == MEMO_AUTH_ALL )
	{
		res = EnableReceiverALL(nCurrentUser);
	}
	else if( enumAuth == MEMO_AUTH_LARGE_FILE )
	{
		res = EnableReceiverLARGEFILE(nCurrentUser);		
	}
	else if( enumAuth == MEMO_AUTH_MANY_RECEIVER )
	{
		res = EnableReceiverMANYRECEIVER(nCurrentUser);
	}
	else if( enumAuth == MEMO_AUTH_NONE )
	{
		res = EnableReceiverNONE(nCurrentUser);
	}

	return res;
	
}

/*
	(÷ ߰ )
	 : NONE
		30M ÷ΰ
	 : NT01 | NT02
		߰Ǿ ִ ڰ 10 ۰ų ̸, 500M  ÷ΰ
		߰Ǿ ִ ڰ 10 , 50 ۰ų ̸, 30M  ÷ΰ
		߰Ǿ ִ ڰ 50 ̰, 1000 ۰ų ̸, 10M  ÷ΰ
	 : NT01
		߰Ǿ ִ ڰ 10 ̰ 50 ۴̸, 30M  ÷ΰ
		߰Ǿ ִ ڰ 10 ۰ų ̸, 500M  ÷ΰ
	 : NT02
		߰Ǿ ִ ڰ 50 ̰ 1000 ۴̸, 10M  ÷ΰ
		߰Ǿ ִ ڰ 50 ۰ų ̸, 30M  ÷ΰ
*/
LRESULT CNoteModel::IsEnableSendFileInfo(ULONGLONG ullFileSize)
{
	LRESULT res = 0L;
	EMemoAuth enumAuth = GetMemoAuth();		
	
	if( enumAuth == MEMO_AUTH_ALL )
	{
		res = EnableFileALL(ullFileSize);		
	}
	else if( enumAuth == MEMO_AUTH_LARGE_FILE )
	{
		res = EnableFileLARGEFILE(ullFileSize);
	}
	else if( enumAuth == MEMO_AUTH_MANY_RECEIVER )
	{
		res = EnableFileMANYRECEIVER(ullFileSize);
	}
	else if( enumAuth == MEMO_AUTH_NONE )
	{
		res = EnableFileNONE(ullFileSize);	
	}

	return res;
}

EMemoAuth CNoteModel::GetMemoAuth()
{
	EMemoAuth res = MEMO_AUTH_NONE;

	DWORD dwAuth = GET_APP()->m_pSendNoteManager->GetAuthorize();

	if( (dwAuth & (AUTH_MEMO_NT01 | AUTH_MEMO_NT02)) == (AUTH_MEMO_NT01 | AUTH_MEMO_NT02) )
		res = MEMO_AUTH_ALL;
	else if( (dwAuth & AUTH_MEMO_NT01) == AUTH_MEMO_NT01 )
		res = MEMO_AUTH_LARGE_FILE;
	else if( (dwAuth & AUTH_MEMO_NT02) == AUTH_MEMO_NT02 )
		res = MEMO_AUTH_MANY_RECEIVER;
	else if( (dwAuth & AUTH_MEMO_NONE) == AUTH_MEMO_NONE )
		res = MEMO_AUTH_NONE;	

	return res;
}

LRESULT CNoteModel::EnableReceiverALL(int nCurrentUser)
{
	LRESULT res = 0L;
	ULONGLONG ullTotalSize = GET_APP()->m_pSendNoteManager->GetCurrentFileSize();

	if(ullTotalSize <= FILE_MAX_NT02)
	{
		if(nCurrentUser <= RECEIVER_MAX_NT02)	res = SUCCESS_RECEIVER;
		else									res = FAIL_RECEIVER_OVER1000;		
	}
	else if(ullTotalSize > FILE_MAX_NT02 && 
				ullTotalSize <= FILE_MAX_DEFAULT)
	{
		if(nCurrentUser <= RECEIVER_MAX_DEFAULT)	res = SUCCESS_RECEIVER;
		else										res = FAIL_RECEIVER_OVER50;
	}
	else if(ullTotalSize > FILE_MAX_DEFAULT && 
					ullTotalSize <= FILE_MAX_NT01)
	{
		if(nCurrentUser <= RECEIVER_MAX_NT01)	res = SUCCESS_RECEIVER;
		else									res = FAIL_RECEIVER_OVER10;
	}
	else
		ASSERT(FALSE);

	return res;
}

LRESULT CNoteModel::EnableReceiverLARGEFILE(int nCurrentUser)
{
	LRESULT res = 0L;
	ULONGLONG ullTotalSize = GET_APP()->m_pSendNoteManager->GetCurrentFileSize();

	if(ullTotalSize <= FILE_MAX_DEFAULT)
	{
		if(nCurrentUser <= RECEIVER_MAX_DEFAULT)	res = SUCCESS_RECEIVER;
		else										res = FAIL_RECEIVER_OVER50;
	}
	else if(ullTotalSize > FILE_MAX_DEFAULT && 
					ullTotalSize <= FILE_MAX_NT01)
	{
		if(nCurrentUser <= RECEIVER_MAX_NT01)	res = SUCCESS_RECEIVER;
		else									res = FAIL_RECEIVER_OVER10;
	}
	else
		ASSERT(FALSE);

	return res;
}

LRESULT CNoteModel::EnableReceiverMANYRECEIVER(int nCurrentUser)
{
	LRESULT res = 0L;
	ULONGLONG ullTotalSize = GET_APP()->m_pSendNoteManager->GetCurrentFileSize();

	if(ullTotalSize <= FILE_MAX_NT02)
	{
		if(nCurrentUser <= RECEIVER_MAX_NT02)	res = SUCCESS_RECEIVER;
		else									res = FAIL_RECEIVER_OVER1000;
	}
	else if(ullTotalSize > FILE_MAX_NT02 && 
				ullTotalSize <= FILE_MAX_DEFAULT)
	{
		if(nCurrentUser <= RECEIVER_MAX_DEFAULT)	res = SUCCESS_RECEIVER;
		else										res = FAIL_RECEIVER_OVER50;
	}
	else
		ASSERT(FALSE);

	return res;
}

LRESULT CNoteModel::EnableReceiverNONE(int nCurrentUser)
{
	LRESULT res = 0L;
	ULONGLONG ullTotalSize = GET_APP()->m_pSendNoteManager->GetCurrentFileSize();

	if( nCurrentUser <= RECEIVER_MAX_DEFAULT )	res = SUCCESS_RECEIVER;
	else										res = FAIL_RECEIVER_OVER50;

	return res;
}

LRESULT CNoteModel::EnableFileALL(ULONGLONG ullFileSize)
{
	LRESULT res = 0L;
	int nCurrentReceiveUser = GetCurrentReceiverCount();

	if(nCurrentReceiveUser <= RECEIVER_MAX_NT01)
	{
		if(ullFileSize <= FILE_MAX_NT01)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER500;
	}
	else if(nCurrentReceiveUser > RECEIVER_MAX_NT01 && 
				nCurrentReceiveUser <= RECEIVER_MAX_DEFAULT)
	{
		if(ullFileSize <= FILE_MAX_DEFAULT)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER30;
	}
	else if(nCurrentReceiveUser > RECEIVER_MAX_DEFAULT)
	{
		if(ullFileSize <= FILE_MAX_NT02)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER10;
	}
	else
		ASSERT(FALSE);

	return res;

}

LRESULT	CNoteModel::EnableFileLARGEFILE(ULONGLONG ullFileSize)
{
	LRESULT res = 0L;

	int nCurrentReceiveUser = GetCurrentReceiverCount();

	if(nCurrentReceiveUser <= RECEIVER_MAX_NT01)
	{
		if(ullFileSize <= FILE_MAX_NT01)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER500;
	}
	else if(nCurrentReceiveUser > RECEIVER_MAX_NT01 && 
				nCurrentReceiveUser <= RECEIVER_MAX_DEFAULT)
	{
		if(ullFileSize <= FILE_MAX_DEFAULT)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER30;
	}
	else
		ASSERT(FALSE);

	return res;
}

LRESULT	CNoteModel::EnableFileMANYRECEIVER(ULONGLONG ullFileSize)
{
	LRESULT res = 0L;

	int nCurrentReceiveUser = GetCurrentReceiverCount();
	
	if(nCurrentReceiveUser <= RECEIVER_MAX_DEFAULT)
	{
		if(ullFileSize <= FILE_MAX_DEFAULT)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER30;
	}
	else if(nCurrentReceiveUser > RECEIVER_MAX_DEFAULT && 
					nCurrentReceiveUser <= RECEIVER_MAX_NT02)
	{
		if(ullFileSize <= FILE_MAX_NT02)	res = SUCCESS_FILE;
		else								res = FAIL_FILE_OVER10;
	}
	else
		ASSERT(FALSE);

	return res;
}

LRESULT	CNoteModel::EnableFileNONE(ULONGLONG ullFileSize)
{
	LRESULT res = 0L;
	int nCurrentReceiveUser = GetCurrentReceiverCount();

	if(ullFileSize <= FILE_MAX_DEFAULT)	res = SUCCESS_FILE;
	else								res = FAIL_FILE_OVER30;

	return res;
}

/*!
*  @fn void AddNoteReceiver()
*  @brief     ޴  ߰Ѵ. 
*  @return    
*  @param     CString strUserID
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning    𵨿 ڸ ϴ° Mapͷ Ѵ.
*/
BOOL CNoteModel::AddNoteReceiver(CString strUserID, CString strUserName)
{
	bool bReturn = FALSE;

	ReceiverInfo ri;
	ri.strID = strUserID;
	ri.strName = strUserName;
	if (std::find(m_receiverVector.begin(), m_receiverVector.end(), ri) == m_receiverVector.end())
	{
		m_receiverVector.push_back(ri);
		bReturn = TRUE;
	}

	return bReturn;
}

/*!
*  @fn void RemoveNoteReceiver()
*  @brief     ޴  Ѵ
*  @return    
*  @param     CString strUserID  ID
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning   
*/
void CNoteModel::RemoveNoteReceiver(CString strUserID)
{
	ReceiverInfo find;
	find.strID = strUserID;
	std::vector<ReceiverInfo>::const_iterator receiverInfoInterator = std::find(m_receiverVector.begin(), m_receiverVector.end(), find);
	if (receiverInfoInterator != m_receiverVector.end())
	{
		m_receiverVector.erase(receiverInfoInterator);
	}
	else
	{
		ASSERT(FALSE);
	}
}
/*!
*  @fn void RemoveAllNoteReceiver()
*  @brief     ޴    Ѵ.
*  @return    
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning   
*/
void CNoteModel::RemoveAllNoteReceiver()
{
	m_receiverVector.clear();
}

/*!
*  @fn void RequestPostData()
*  @brief     ƼƮ  ͸   κ
*  @return    
*  @param     CHttpFile * pHTTP 
*  @param     CString strFormData  
*  @author	  yangjae.park(yangjae.park@nhn.com) 
*  @date      2012/02/23
*  @warning   
*/
void CNoteModel::RequestPostData(CHttpFile* pHTTP, CString strFormData)
{
	const int dwLen = WideCharToMultiByte(CP_UTF8, 0, strFormData, -1, NULL, 0, NULL, NULL)-1;//_tcslen(strFormData)+1;
	char *lpFormData = new char[dwLen];
	if (NULL == lpFormData)
		return;

	WideCharToMultiByte(CP_UTF8, 0, strFormData, -1, lpFormData, dwLen, 0, 0); 
	pHTTP->Write((LPVOID)lpFormData, dwLen); 
	delete[] lpFormData;
	return;
}



